Loading...
Searching...
No Matches
BALL::PersistentObject Class Reference
Foundation Classes » Concepts » Object Persistence.

`#include <BALL/CONCEPT/persistentObject.h>`

Inheritance diagram for BALL::PersistentObject:

## Public Member Functions

Constructors and Destructors
| PersistentObject ()
virtual | ~PersistentObject ()
Persistent Writing and Reading
PersistenceManager & | operator>> (PersistenceManager &pm) const
virtual void | persistentWrite (PersistenceManager &pm, const char *name="") const
virtual void | persistentRead (PersistenceManager &pm)
virtual void | finalize ()
Public Member Functions inherited from BALL::Object
| Object ()
| Default constructor.
| Object (const Object &object)
| Copy constructor.
virtual | ~Object ()
| Destructor.
virtual void | clear ()
| Clear function of the OCI, doing nothing here.
const Object & | operator= (const Object &)
bool | operator== (const Object &object) const
bool | operator!= (const Object &object) const
bool | operator< (const Object &object) const
bool | operator<= (const Object &object) const
bool | operator>= (const Object &object) const
bool | operator> (const Object &object) const
int | compare (const Object &object) const
virtual bool | isValid () const
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const
Handle | getHandle () const
Public Member Functions inherited from BALL::AutoDeletable
virtual | ~AutoDeletable ()
void * | operator new (size_t size)
void | operator delete (void *ptr)
void * | operator new (size_t size, void *ptr)
void | operator delete (void *ptr, void *)
bool | isAutoDeletable () const
void | setAutoDeletable (bool enable)

## Additional Inherited Members

static Handle | getNextHandle ()
static Handle | getNewHandle ()
static void | clearLastPtr ()
| AutoDeletable ()
| AutoDeletable (const AutoDeletable &auto_deletable, bool deep=false)

## Detailed Description

The persistent object. Each object that needs persistence, has to be derived from PersistentObject to define an interface to the PersistenceManager .

  The class itself has no functionality except for the operator >>.

Definition at line 27 of file persistentObject.h.

## Constructor & Destructor Documentation

## PersistentObject()

BALL::PersistentObject::PersistentObject | ( |  | ) |

inline

Default constructor. The default constructor has no functionality.

Definition at line 39 of file persistentObject.h.

## ~PersistentObject()

virtual BALL::PersistentObject::~PersistentObject | ( |  | ) |

inline virtual

Destructor. The destructor has no functionality.

Definition at line 47 of file persistentObject.h.

## Member Function Documentation

## finalize()

virtual void BALL::PersistentObject::finalize | ( |  | ) |

inline virtual

Finalize the deserialization. This method is called for all objects after their pointers have been demangled. It is intended for the adaptation of internal data structures. For example, the bond class has to swap first_ and second_ depending on the order of the atoms. It is usually left unimplemented.

Exceptions

  Exception::GeneralException |

Reimplemented in BALL::Bond.

Definition at line 103 of file persistentObject.h.

## operator>>()

PersistenceManager & BALL::PersistentObject::operator>> | ( | PersistenceManager & | pm | ) | const

Stream operator. This operator is used to serialize an instance of PersistentObject. The method first calls pm.startOutput() to write the necessary headers. Then, persistentWrite(pm) is called to serialize the object. Finally, a call to pm.stopOutput() writes all dependend objects and the end marker to the persistent stream.

Parameters

  pm | the persistence manager

Exceptions

  Exception::GeneralException |

Returns
  the persistence manager (for chaining multiple output operations)

## persistentRead()

virtual void BALL::PersistentObject::persistentRead | ( | PersistenceManager & | pm | ) |

virtual

Deserialize the object. This method reads the contents of an persistent object into an (already existing!) object. It is implemented using Layer 1 commands of PersistenceManager. To each write command used in persistentWrite, there should be exactly the same call to a read command in persistentRead. Only the header and trailer (writeObjectHeader/writeObjectTrailer calls) have to be omitted, as the header is read before this method is called (the object type has to be known in advance to dynamically create the object).

Parameters

  pm | the PersistenceManager

Exceptions

  Exception::GeneralException |

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Chain, BALL::Composite, BALL::CrystalInfo, BALL::Fragment, BALL::Molecule, BALL::NamedProperty, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::PDBInfo, BALL::PDBRecords, BALL::Protein, BALL::Residue, BALL::SecondaryStructure, BALL::System, BALL::TVector2< T >, BALL::TVector2< float >, and BALL::VIEW::Stage::Material.

## persistentWrite()

virtual void BALL::PersistentObject::persistentWrite | ( | PersistenceManager & | pm,
|  | const char * | name = "" ) const

virtual

Serialize the object. This method serializes the object by calls to Layer 1 methods of PersistenceManager . The first method in the implementation of persistentRead should be a call to pm.writeObjectHeader(*this, name). Likewise the last method in this method should be pm.writeObjectTrailer(name).

Parameters

  pm | the persistence manager
  name | the name of the object (0 for writing base classes)

Exceptions

  Exception::GeneralException |

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Chain, BALL::Composite, BALL::CrystalInfo, BALL::Fragment, BALL::Molecule, BALL::NamedProperty, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::PDBInfo, BALL::PDBRecords, BALL::Protein, BALL::Residue, BALL::SecondaryStructure, BALL::System, BALL::TVector2< T >, BALL::TVector2< float >, and BALL::VIEW::Stage::Material.